<id>
IM small Enhancement
</id>

<version>
1.0
</version>

<mod info>
This mod allows the admin to limit the number of stored messages in the in- and output seperately.
Bonus: If a user has new IMs in his inbox it will be indicated through the <yabb im> tag.
------
The default limit is set to 10 messages for the in- and 10 for the outbox. These settings may be adjusted
through the admin control center (forum preferences and settings).

If the box is at its limit, the oldest message will be deleted after the newest has been added...

This Mod affects all accounts, but the new limit will only be applied after a user sends and receives new IMs ;)

I know there is the great AdvancedIMBox Mod! But I had some trouble and collisions with other modifications.
So I wrote my personal, small Mod with the only enhancements I really wanted to have ;)
</mod info>

<author>
|_TRoN_|
</author>

<homepage>
http://www.digital-joker.de/forum
</homepage>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
	unlink("$memberdir/$currentmem.imconfig");
</search for>

<add after>
	unlink("$memberdir/$currentmem.newim");
</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		else { $yyim = qq~$txt{'152'} <a href="$cgi;action=im">$mnum $txt{'153'}</a>.~; }
</search for>

<add after>
		if(-e("$memberdir/$username.newim")) { $yyim .= qq~ (<a href="$cgi;action=im">$txt{'321'}</a>!)~; } # IM small Enhancement Mod by |_TRoN_|
</add after>

<edit file>
Sources/InstantMessage.pl
</edit file>

<search for>
sub IMIndex {
	if( $username eq 'Guest' ) { &fatal_error($txt{'147'}); }
</search for>

<add after>

	# IM small Enhancement Mod by |_TRoN_| - START
	if(-e("$memberdir/$username.newim")) { unlink ("$memberdir/$username.newim"); }
	# IM small Enhancement Mod by |_TRoN_| - END
</add after>

<search for>
	print FILE "$db|$subject|$date|$message|$messageid|$user_ip\n";
	fclose(FILE);
</search for>

<add after>

	# IM small Enhancement Mod by |_TRoN_| - START
	fopen(FILE, "$memberdir/$username.outbox");
	@outims = <FILE>;
	fclose(FILE);

	fopen(FILE, ">$memberdir/$username.outbox", 1);
	$maxoutbox = $outboxlimit - 1;
	while ($#outims > $maxoutbox) {shift (@outims);}
	print FILE @outims;
	fclose(FILE);
	# IM small Enhancement Mod by |_TRoN_| - END
</add after>

<search for>
		print FILE "$username|$subject|$date|$message|$messageid|$user_ip\n";
		fclose(FILE);
</search for>

<add after>

		# IM small Enhancement Mod by |_TRoN_| - START
		fopen(FILE, "$memberdir/$db.msg");
		@inims = <FILE>;
		fclose(FILE);
	
		fopen(FILE, ">$memberdir/$db.msg", 1);
		$maxinbox = $inboxlimit - 1;
		while ($#inims > $maxinbox) {shift (@inims);}
		print FILE @inims;
		fclose(FILE);
		
		if(!-e("$memberdir/$db.newim")) { fopen(FILE, ">$memberdir/$db.newim" ); fclose(FILE); } # Set "New IMs" for Boardindex (Load.pl)
		# IM small Enhancement Mod by |_TRoN_| - END

</add after>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'619'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailwelcome"$welchecked></td>
  </tr><tr>
</search for>

<add after>
<! IM small Enhancement Mod by |_TRoN_| - START>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imehtxt{'1'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="inboxlimit" size="5" value="$inboxlimit"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imehtxt{'2'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="outboxlimit" size="5" value="$outboxlimit"></td>
  </tr><tr>
<! IM small Enhancement Mod by |_TRoN_| - END>
</add after>

<search for>
	if ($maintenance) { $mainchecked = ' checked'; }
</search for>

<add before>
	$inboxlimit ||= 10; # IM small Enhancement Mod by |_TRoN_|
	$outboxlimit ||= 10; # IM small Enhancement Mod by |_TRoN_|
</add before>

<search for>
\$emailwelcome = $emailwelcome;				# Set to 1 to email a welcome message to users even when you have mail password turned off
</search for>

<add after>
\$inboxlimit = $inboxlimit;			        # Limit IM inbox to # of messages (mod by |_TRoN_|)
\$outboxlimit = $outboxlimit;			        # Limit IM outbox to # of messages (mod by |_TRoN_|)
</add after>

<search for>
	$color{'fadertext'} = $FORM{'fadertext'} || '#D4AD00';
</search for>

<add after>
	$inboxlimit = $FORM{'inboxlimit'} || 10; # IM small Enhancement Mod by |_TRoN_|
	$outboxlimit = $FORM{'outboxlimit'} || 10; # IM small Enhancement Mod by |_TRoN_|
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'100'} = "The username you tried to register already exists.";
</search for>

<add after>
$imehtxt{'1'} = "Limit IM inbox to # of messages";
$imehtxt{'2'} = "Limit IM outbox to # of messages";
</add after>